:: Validate, and remove quotes from command line arguments
SET currentWorkingDirectory=%~dp0

SET vcInstallDir=%~1
SHIFT

SET sourceDir=%~1
SHIFT

:: Call for every file matching *.definition pattern, replace .definition extension with .h
FOR /R "%sourceDir%" %%f IN (*.autogen.def) DO (
	:: Generate code
	COPY "%%f" "%%f.h" > NUL
	"%vcInstallDir%bin\cl.exe" /nologo /EP "%%f.h" > tmp

	:: Make it pretty
	"%currentWorkingDirectory%Astyle.exe" --style=ansi --indent-namespaces --delete-empty-lines --quiet tmp

	ECHO // Automatically generated, don't manually edit this file > "%sourceDir%\%%~nf.h"
	COPY tmp "%sourceDir%\%%~nf.h" > NUL

	:: Delete temporaries
	DEL "%sourceDir%\%%f.h" > NUL
	DEL tmp.orig > NUL
	DEL tmp > NUL
)
