#!/bin/bash

currentWorkingDirectory=`dirname $0`

sourceDir=$1

# Call for every file matching *.autogen.def pattern, replace .autogen.def extension with .h
for sourceFile in `find $sourceDir | grep -F .autogen.def`
do
	# Generate code
	g++ -xc++ $sourceFile -E -P -o tmp

	# Make it pretty, add warning
	$currentWorkingDirectory/Astyle.linux --style=ansi --indent-namespaces --delete-empty-lines --quiet tmp

	echo "// Automatically generated, don't manually edit this file" > ${sourceFile%.*}.h
	cat tmp >> ${sourceFile%.*}.h

	# Delete temporary
	rm -f tmp.orig
	rm -f tmp
done
