#ifndef XML_SERIALIZER_H
#define XML_SERIALIZER_H


#include "ISerializer.h"
#include <stdio.h>


/**
 * @class XMLSerializer
 * 
 * @brief Simple example of a serializer implementation, which writes any visited input as an XML document
 */
class XMLSerializer
:    public ISerializer
{
public:

    using ISerializer::Serialize;

    /**
     * Constructor
     * 
     * @param a_pFile pointer to the output file to write to
     */
    XMLSerializer(FILE *a_pFile);

    virtual bool IsWritingToObject() const;

    virtual bool Serialize(    bool &a_Value, const char *a_Name);
    virtual bool Serialize(    char &a_Value, const char *a_Name);

    virtual bool Serialize(  int8_t &a_Value, const char *a_Name);
    virtual bool Serialize( int16_t &a_Value, const char *a_Name);
    virtual bool Serialize( int32_t &a_Value, const char *a_Name);
    virtual bool Serialize( int64_t &a_Value, const char *a_Name);
    virtual bool Serialize( uint8_t &a_Value, const char *a_Name);
    virtual bool Serialize(uint16_t &a_Value, const char *a_Name);
    virtual bool Serialize(uint32_t &a_Value, const char *a_Name);
    virtual bool Serialize(uint64_t &a_Value, const char *a_Name);

    virtual bool Serialize(ISerializable &a_Value, const char *a_Name);

private:

    FILE    *m_pFile;
    uint32_t m_iIndentLevel;

};


#endif
