#ifndef NETWORK_OUTPUT_SERIALIZER_H
#define NETWORK_OUTPUT_SERIALIZER_H


#include "ISerializer.h"


/**
 * @class NetworkOutputSerializer
 * 
 * @brief Simple example of a binary network serialize writer, definitely not production code...
 */
class NetworkOutputSerializer
:    public ISerializer
{
public:

    /**
     * Constructor
     * 
     * @param a_pBuffer         input buffer to write to
     * @param a_iBufferCapacity capacity of the buffer in bytes
     */
    NetworkOutputSerializer(const uint8_t *a_pBuffer, uint32_t a_iBufferCapacity);

    /**
     * Returns the number of bytes not yet consumed from the serialization buffer
     * 
     * @return number of bytes not yet consumed from the serialization buffer
     */
    uint32_t GetUnreadSize() const;

    // ISerializer interfaces
    virtual bool IsWritingToObject() const;
    virtual bool Serialize(    bool &a_Value, const char *a_Name);
    virtual bool Serialize(    char &a_Value, const char *a_Name);
    virtual bool Serialize(  int8_t &a_Value, const char *a_Name);
    virtual bool Serialize( int16_t &a_Value, const char *a_Name);
    virtual bool Serialize( int32_t &a_Value, const char *a_Name);
    virtual bool Serialize( int64_t &a_Value, const char *a_Name);
    virtual bool Serialize( uint8_t &a_Value, const char *a_Name);
    virtual bool Serialize(uint16_t &a_Value, const char *a_Name);
    virtual bool Serialize(uint32_t &a_Value, const char *a_Name);
    virtual bool Serialize(uint64_t &a_Value, const char *a_Name);
    virtual bool Serialize(ISerializable &a_Value, const char *a_Name);
    // ISerializer interfaces

private:

    bool SerializeBytes(uint8_t *a_pData, uint32_t a_iCount);

    bool     m_bSerializationFailed;

    uint32_t m_iBufferPosition;

    const uint8_t *m_pBuffer;

    const uint32_t m_iBufferCapacity;

};


#endif
