#ifndef STRONG_TYPEDEF_INL
#define STRONG_TYPEDEF_INL


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline StrongTypedef<BASE_TYPE, NAME_FUNC>::StrongTypedef()
{
    ;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline StrongTypedef<BASE_TYPE, NAME_FUNC>::StrongTypedef(const StrongTypedef<BASE_TYPE, NAME_FUNC> &a_RHS)
:   m_Type(a_RHS.m_Type)
{
    ;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline StrongTypedef<BASE_TYPE, NAME_FUNC>::StrongTypedef(const BASE_TYPE &a_RHS)
:   m_Type(a_RHS)
{
    ;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline StrongTypedef<BASE_TYPE, NAME_FUNC> &StrongTypedef<BASE_TYPE, NAME_FUNC>::operator = (const StrongTypedef &a_RHS)
{
    m_Type = a_RHS.m_Type;
    return *this;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline StrongTypedef<BASE_TYPE, NAME_FUNC> &StrongTypedef<BASE_TYPE, NAME_FUNC>::operator = (const BASE_TYPE &a_RHS)
{
    m_Type = a_RHS;
    return *this;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline StrongTypedef<BASE_TYPE, NAME_FUNC>::operator const BASE_TYPE& () const
{
    return m_Type;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline StrongTypedef<BASE_TYPE, NAME_FUNC>::operator BASE_TYPE& ()
{
    return m_Type;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline bool StrongTypedef<BASE_TYPE, NAME_FUNC>::operator == (const StrongTypedef<BASE_TYPE, NAME_FUNC> &a_RHS) const
{
    return m_Type == a_RHS.m_Type;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline bool StrongTypedef<BASE_TYPE, NAME_FUNC>::operator != (const StrongTypedef<BASE_TYPE, NAME_FUNC> &a_RHS) const
{
    return m_Type != a_RHS.m_Type;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline bool StrongTypedef<BASE_TYPE, NAME_FUNC>::operator < (const StrongTypedef<BASE_TYPE, NAME_FUNC> &a_RHS) const
{
    return m_Type < a_RHS.m_Type;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline bool StrongTypedef<BASE_TYPE, NAME_FUNC>::operator <= (const StrongTypedef<BASE_TYPE, NAME_FUNC> &a_RHS) const
{
    return m_Type <= a_RHS.m_Type;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline bool StrongTypedef<BASE_TYPE, NAME_FUNC>::operator > (const StrongTypedef<BASE_TYPE, NAME_FUNC> &a_RHS) const
{
    return m_Type > a_RHS.m_Type;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline bool StrongTypedef<BASE_TYPE, NAME_FUNC>::operator >= (const StrongTypedef<BASE_TYPE, NAME_FUNC> &a_RHS) const
{
    return m_Type >= a_RHS.m_Type;
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline const char *StrongTypedef<BASE_TYPE, NAME_FUNC>::GetSerializableClassName() const
{
    return (*NAME_FUNC)();
}


template <typename BASE_TYPE, NameFunc NAME_FUNC>
inline bool StrongTypedef<BASE_TYPE, NAME_FUNC>::Serialize(ISerializer &a_Serializer, const char *a_Name)
{
    return a_Serializer.Serialize(m_Type, a_Name);
}


#endif
